// Targeted by JavaCPP version 1.4.1: DO NOT EDIT THIS FILE

package org.bytedeco.javacpp;

import java.nio.*;
import org.bytedeco.javacpp.*;
import org.bytedeco.javacpp.annotation.*;

import static org.bytedeco.javacpp.opencv_core.*;
import static org.bytedeco.javacpp.opencv_imgproc.*;

public class opencv_imgcodecs extends org.bytedeco.javacpp.helper.opencv_imgcodecs {
    static { Loader.load(); }

// Parsed from <opencv2/imgcodecs/imgcodecs_c.h>

/*M///////////////////////////////////////////////////////////////////////////////////////
//
//  IMPORTANT: READ BEFORE DOWNLOADING, COPYING, INSTALLING OR USING.
//
//  By downloading, copying, installing or using the software you agree to this license.
//  If you do not agree to this license, do not download, install,
//  copy or use the software.
//
//
//                        Intel License Agreement
//                For Open Source Computer Vision Library
//
// Copyright (C) 2000, Intel Corporation, all rights reserved.
// Third party copyrights are property of their respective owners.
//
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
//
//   * Redistribution's of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//
//   * Redistribution's in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//
//   * The name of Intel Corporation may not be used to endorse or promote products
//     derived from this software without specific prior written permission.
//
// This software is provided by the copyright holders and contributors "as is" and
// any express or implied warranties, including, but not limited to, the implied
// warranties of merchantability and fitness for a particular purpose are disclaimed.
// In no event shall the Intel Corporation or contributors be liable for any direct,
// indirect, incidental, special, exemplary, or consequential damages
// (including, but not limited to, procurement of substitute goods or services;
// loss of use, data, or profits; or business interruption) however caused
// and on any theory of liability, whether in contract, strict liability,
// or tort (including negligence or otherwise) arising in any way out of
// the use of this software, even if advised of the possibility of such damage.
//
//M*/

// #ifndef OPENCV_IMGCODECS_H
// #define OPENCV_IMGCODECS_H

// #include "opencv2/core/core_c.h"

// #ifdef __cplusplus
// #endif /* __cplusplus */

/** \addtogroup imgcodecs_c
  \{
  */

/** enum  */
public static final int
/* 8bit, color or not */
    CV_LOAD_IMAGE_UNCHANGED  = -1,
/* 8bit, gray */
    CV_LOAD_IMAGE_GRAYSCALE  = 0,
/* ?, color */
    CV_LOAD_IMAGE_COLOR      = 1,
/* any depth, ? */
    CV_LOAD_IMAGE_ANYDEPTH   = 2,
/* ?, any color */
    CV_LOAD_IMAGE_ANYCOLOR   = 4,
/* ?, no rotate */
    CV_LOAD_IMAGE_IGNORE_ORIENTATION  = 128;

/* load image from file
  iscolor can be a combination of above flags where CV_LOAD_IMAGE_UNCHANGED
  overrides the other flags
  using CV_LOAD_IMAGE_ANYCOLOR alone is equivalent to CV_LOAD_IMAGE_UNCHANGED
  unless CV_LOAD_IMAGE_ANYDEPTH is specified images are converted to 8bit
*/
public static native IplImage cvLoadImage( @Cast("const char*") BytePointer filename, int iscolor/*=CV_LOAD_IMAGE_COLOR*/);
public static native IplImage cvLoadImage( @Cast("const char*") BytePointer filename);
public static native IplImage cvLoadImage( String filename, int iscolor/*=CV_LOAD_IMAGE_COLOR*/);
public static native IplImage cvLoadImage( String filename);
public static native CvMat cvLoadImageM( @Cast("const char*") BytePointer filename, int iscolor/*=CV_LOAD_IMAGE_COLOR*/);
public static native CvMat cvLoadImageM( @Cast("const char*") BytePointer filename);
public static native CvMat cvLoadImageM( String filename, int iscolor/*=CV_LOAD_IMAGE_COLOR*/);
public static native CvMat cvLoadImageM( String filename);

/** enum  */
public static final int
    CV_IMWRITE_JPEG_QUALITY = 1,
    CV_IMWRITE_JPEG_PROGRESSIVE = 2,
    CV_IMWRITE_JPEG_OPTIMIZE = 3,
    CV_IMWRITE_JPEG_RST_INTERVAL = 4,
    CV_IMWRITE_JPEG_LUMA_QUALITY = 5,
    CV_IMWRITE_JPEG_CHROMA_QUALITY = 6,
    CV_IMWRITE_PNG_COMPRESSION = 16,
    CV_IMWRITE_PNG_STRATEGY = 17,
    CV_IMWRITE_PNG_BILEVEL = 18,
    CV_IMWRITE_PNG_STRATEGY_DEFAULT = 0,
    CV_IMWRITE_PNG_STRATEGY_FILTERED = 1,
    CV_IMWRITE_PNG_STRATEGY_HUFFMAN_ONLY = 2,
    CV_IMWRITE_PNG_STRATEGY_RLE = 3,
    CV_IMWRITE_PNG_STRATEGY_FIXED = 4,
    CV_IMWRITE_PXM_BINARY = 32,
    CV_IMWRITE_EXR_TYPE = 48,
    CV_IMWRITE_WEBP_QUALITY = 64,
    CV_IMWRITE_PAM_TUPLETYPE = 128,
    CV_IMWRITE_PAM_FORMAT_NULL = 0,
    CV_IMWRITE_PAM_FORMAT_BLACKANDWHITE = 1,
    CV_IMWRITE_PAM_FORMAT_GRAYSCALE = 2,
    CV_IMWRITE_PAM_FORMAT_GRAYSCALE_ALPHA = 3,
    CV_IMWRITE_PAM_FORMAT_RGB = 4,
    CV_IMWRITE_PAM_FORMAT_RGB_ALPHA = 5;



/* save image to file */
public static native int cvSaveImage( @Cast("const char*") BytePointer filename, @Const CvArr image,
                        @Const IntPointer params/*=0*/ );
public static native int cvSaveImage( @Cast("const char*") BytePointer filename, @Const CvArr image );
public static native int cvSaveImage( String filename, @Const CvArr image,
                        @Const IntBuffer params/*=0*/ );
public static native int cvSaveImage( String filename, @Const CvArr image );
public static native int cvSaveImage( @Cast("const char*") BytePointer filename, @Const CvArr image,
                        @Const int[] params/*=0*/ );
public static native int cvSaveImage( String filename, @Const CvArr image,
                        @Const IntPointer params/*=0*/ );
public static native int cvSaveImage( @Cast("const char*") BytePointer filename, @Const CvArr image,
                        @Const IntBuffer params/*=0*/ );
public static native int cvSaveImage( String filename, @Const CvArr image,
                        @Const int[] params/*=0*/ );

/* decode image stored in the buffer */
public static native IplImage cvDecodeImage( @Const CvMat buf, int iscolor/*=CV_LOAD_IMAGE_COLOR*/);
public static native IplImage cvDecodeImage( @Const CvMat buf);
public static native CvMat cvDecodeImageM( @Const CvMat buf, int iscolor/*=CV_LOAD_IMAGE_COLOR*/);
public static native CvMat cvDecodeImageM( @Const CvMat buf);

/* encode image and store the result as a byte vector (single-row 8uC1 matrix) */
public static native CvMat cvEncodeImage( @Cast("const char*") BytePointer ext, @Const CvArr image,
                             @Const IntPointer params/*=0*/ );
public static native CvMat cvEncodeImage( @Cast("const char*") BytePointer ext, @Const CvArr image );
public static native CvMat cvEncodeImage( String ext, @Const CvArr image,
                             @Const IntBuffer params/*=0*/ );
public static native CvMat cvEncodeImage( String ext, @Const CvArr image );
public static native CvMat cvEncodeImage( @Cast("const char*") BytePointer ext, @Const CvArr image,
                             @Const int[] params/*=0*/ );
public static native CvMat cvEncodeImage( String ext, @Const CvArr image,
                             @Const IntPointer params/*=0*/ );
public static native CvMat cvEncodeImage( @Cast("const char*") BytePointer ext, @Const CvArr image,
                             @Const IntBuffer params/*=0*/ );
public static native CvMat cvEncodeImage( String ext, @Const CvArr image,
                             @Const int[] params/*=0*/ );

/** enum  */
public static final int
    CV_CVTIMG_FLIP      = 1,
    CV_CVTIMG_SWAP_RB   = 2;

/* utility function: convert one image to another with optional vertical flip */
public static native void cvConvertImage( @Const CvArr src, CvArr dst, int flags/*=0*/);
public static native void cvConvertImage( @Const CvArr src, CvArr dst);

public static native int cvHaveImageReader(@Cast("const char*") BytePointer filename);
public static native int cvHaveImageReader(String filename);
public static native int cvHaveImageWriter(@Cast("const char*") BytePointer filename);
public static native int cvHaveImageWriter(String filename);


/****************************************************************************************\
*                              Obsolete functions/synonyms                               *
\****************************************************************************************/

public static native IplImage cvvLoadImage(@Cast("const char*") BytePointer name);
public static native IplImage cvvLoadImage(String name);
public static native int cvvSaveImage(@Cast("const char*") BytePointer arg1, CvArr arg2, IntPointer arg3);
public static native int cvvSaveImage(String arg1, CvArr arg2, IntBuffer arg3);
public static native int cvvSaveImage(@Cast("const char*") BytePointer arg1, CvArr arg2, int[] arg3);
public static native int cvvSaveImage(String arg1, CvArr arg2, IntPointer arg3);
public static native int cvvSaveImage(@Cast("const char*") BytePointer arg1, CvArr arg2, IntBuffer arg3);
public static native int cvvSaveImage(String arg1, CvArr arg2, int[] arg3);
public static native void cvvConvertImage(CvArr arg1, CvArr arg2, int arg3);

/** \} imgcodecs_c */

// #ifdef __cplusplus
// #endif

// #endif // OPENCV_IMGCODECS_H


// Parsed from <opencv2/imgcodecs.hpp>

/*M///////////////////////////////////////////////////////////////////////////////////////
//
//  IMPORTANT: READ BEFORE DOWNLOADING, COPYING, INSTALLING OR USING.
//
//  By downloading, copying, installing or using the software you agree to this license.
//  If you do not agree to this license, do not download, install,
//  copy or use the software.
//
//
//                          License Agreement
//                For Open Source Computer Vision Library
//
// Copyright (C) 2000-2008, Intel Corporation, all rights reserved.
// Copyright (C) 2009, Willow Garage Inc., all rights reserved.
// Third party copyrights are property of their respective owners.
//
// Redistribution and use in source and binary forms, with or without modification,
// are permitted provided that the following conditions are met:
//
//   * Redistribution's of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//
//   * Redistribution's in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//
//   * The name of the copyright holders may not be used to endorse or promote products
//     derived from this software without specific prior written permission.
//
// This software is provided by the copyright holders and contributors "as is" and
// any express or implied warranties, including, but not limited to, the implied
// warranties of merchantability and fitness for a particular purpose are disclaimed.
// In no event shall the Intel Corporation or contributors be liable for any direct,
// indirect, incidental, special, exemplary, or consequential damages
// (including, but not limited to, procurement of substitute goods or services;
// loss of use, data, or profits; or business interruption) however caused
// and on any theory of liability, whether in contract, strict liability,
// or tort (including negligence or otherwise) arising in any way out of
// the use of this software, even if advised of the possibility of such damage.
//
//M*/

// #ifndef OPENCV_IMGCODECS_HPP
// #define OPENCV_IMGCODECS_HPP

// #include "opencv2/core.hpp"

/**
  \defgroup imgcodecs Image file reading and writing
  \{
    \defgroup imgcodecs_c C API
    \defgroup imgcodecs_ios iOS glue
  \}
*/

//////////////////////////////// image codec ////////////////////////////////

/** \addtogroup imgcodecs
 *  \{
 <p>
 *  Imread flags */
/** enum cv::ImreadModes */
public static final int
       /** If set, return the loaded image as is (with alpha channel, otherwise it gets cropped). */
       IMREAD_UNCHANGED            = -1,
       /** If set, always convert image to the single channel grayscale image. */
       IMREAD_GRAYSCALE            = 0,
       /** If set, always convert image to the 3 channel BGR color image. */
       IMREAD_COLOR                = 1,
       /** If set, return 16-bit/32-bit image when the input has the corresponding depth, otherwise convert it to 8-bit. */
       IMREAD_ANYDEPTH             = 2,
       /** If set, the image is read in any possible color format. */
       IMREAD_ANYCOLOR             = 4,
       /** If set, use the gdal driver for loading the image. */
       IMREAD_LOAD_GDAL            = 8,
       /** If set, always convert image to the single channel grayscale image and the image size reduced 1/2. */
       IMREAD_REDUCED_GRAYSCALE_2  = 16,
       /** If set, always convert image to the 3 channel BGR color image and the image size reduced 1/2. */
       IMREAD_REDUCED_COLOR_2      = 17,
       /** If set, always convert image to the single channel grayscale image and the image size reduced 1/4. */
       IMREAD_REDUCED_GRAYSCALE_4  = 32,
       /** If set, always convert image to the 3 channel BGR color image and the image size reduced 1/4. */
       IMREAD_REDUCED_COLOR_4      = 33,
       /** If set, always convert image to the single channel grayscale image and the image size reduced 1/8. */
       IMREAD_REDUCED_GRAYSCALE_8  = 64,
       /** If set, always convert image to the 3 channel BGR color image and the image size reduced 1/8. */
       IMREAD_REDUCED_COLOR_8      = 65,
       /** If set, do not rotate the image according to EXIF's orientation flag. */
       IMREAD_IGNORE_ORIENTATION   = 128;

/** Imwrite flags */
/** enum cv::ImwriteFlags */
public static final int
       /** For JPEG, it can be a quality from 0 to 100 (the higher is the better). Default value is 95. */
       IMWRITE_JPEG_QUALITY        = 1,
       /** Enable JPEG features, 0 or 1, default is False. */
       IMWRITE_JPEG_PROGRESSIVE    = 2,
       /** Enable JPEG features, 0 or 1, default is False. */
       IMWRITE_JPEG_OPTIMIZE       = 3,
       /** JPEG restart interval, 0 - 65535, default is 0 - no restart. */
       IMWRITE_JPEG_RST_INTERVAL   = 4,
       /** Separate luma quality level, 0 - 100, default is 0 - don't use. */
       IMWRITE_JPEG_LUMA_QUALITY   = 5,
       /** Separate chroma quality level, 0 - 100, default is 0 - don't use. */
       IMWRITE_JPEG_CHROMA_QUALITY = 6,
       /** For PNG, it can be the compression level from 0 to 9. A higher value means a smaller size and longer compression time. If specified, strategy is changed to IMWRITE_PNG_STRATEGY_DEFAULT (Z_DEFAULT_STRATEGY). Default value is 1 (best speed setting). */
       IMWRITE_PNG_COMPRESSION     = 16,
       /** One of cv::ImwritePNGFlags, default is IMWRITE_PNG_STRATEGY_RLE. */
       IMWRITE_PNG_STRATEGY        = 17,
       /** Binary level PNG, 0 or 1, default is 0. */
       IMWRITE_PNG_BILEVEL         = 18,
       /** For PPM, PGM, or PBM, it can be a binary format flag, 0 or 1. Default value is 1. */
       IMWRITE_PXM_BINARY          = 32,
       /** override EXR storage type (FLOAT (FP32) is default) */
       IMWRITE_EXR_TYPE            = (3 << 4) + 0, /* 48 */
       /** For WEBP, it can be a quality from 1 to 100 (the higher is the better). By default (without any parameter) and for quality above 100 the lossless compression is used. */
       IMWRITE_WEBP_QUALITY        = 64,
       /** For PAM, sets the TUPLETYPE field to the corresponding string value that is defined for the format */
       IMWRITE_PAM_TUPLETYPE       = 128;

/** enum cv::ImwriteEXRTypeFlags */
public static final int
       /*IMWRITE_EXR_TYPE_UNIT = 0, //!< not supported */
       /** store as HALF (FP16) */
       IMWRITE_EXR_TYPE_HALF = 1,
       /** store as FP32 (default) */
       IMWRITE_EXR_TYPE_FLOAT = 2;

/** Imwrite PNG specific flags used to tune the compression algorithm.
/** These flags will be modify the way of PNG image compression and will be passed to the underlying zlib processing stage.
<p>
-   The effect of IMWRITE_PNG_STRATEGY_FILTERED is to force more Huffman coding and less string matching; it is somewhat intermediate between IMWRITE_PNG_STRATEGY_DEFAULT and IMWRITE_PNG_STRATEGY_HUFFMAN_ONLY.
-   IMWRITE_PNG_STRATEGY_RLE is designed to be almost as fast as IMWRITE_PNG_STRATEGY_HUFFMAN_ONLY, but give better compression for PNG image data.
-   The strategy parameter only affects the compression ratio but not the correctness of the compressed output even if it is not set appropriately.
-   IMWRITE_PNG_STRATEGY_FIXED prevents the use of dynamic Huffman codes, allowing for a simpler decoder for special applications.
*/
/** enum cv::ImwritePNGFlags */
public static final int
       /** Use this value for normal data. */
       IMWRITE_PNG_STRATEGY_DEFAULT      = 0,
       /** Use this value for data produced by a filter (or predictor).Filtered data consists mostly of small values with a somewhat random distribution. In this case, the compression algorithm is tuned to compress them better. */
       IMWRITE_PNG_STRATEGY_FILTERED     = 1,
       /** Use this value to force Huffman encoding only (no string match). */
       IMWRITE_PNG_STRATEGY_HUFFMAN_ONLY = 2,
       /** Use this value to limit match distances to one (run-length encoding). */
       IMWRITE_PNG_STRATEGY_RLE          = 3,
       /** Using this value prevents the use of dynamic Huffman codes, allowing for a simpler decoder for special applications. */
       IMWRITE_PNG_STRATEGY_FIXED        = 4;

/** Imwrite PAM specific tupletype flags used to define the 'TUPETYPE' field of a PAM file. */
/** enum cv::ImwritePAMFlags */
public static final int
       IMWRITE_PAM_FORMAT_NULL = 0,
       IMWRITE_PAM_FORMAT_BLACKANDWHITE = 1,
       IMWRITE_PAM_FORMAT_GRAYSCALE = 2,
       IMWRITE_PAM_FORMAT_GRAYSCALE_ALPHA = 3,
       IMWRITE_PAM_FORMAT_RGB = 4,
       IMWRITE_PAM_FORMAT_RGB_ALPHA = 5;

/** \brief Loads an image from a file.
<p>
\anchor imread
<p>
The function imread loads an image from the specified file and returns it. If the image cannot be
read (because of missing file, improper permissions, unsupported or invalid format), the function
returns an empty matrix ( Mat::data==NULL ).
<p>
Currently, the following file formats are supported:
<p>
-   Windows bitmaps - \*.bmp, \*.dib (always supported)
-   JPEG files - \*.jpeg, \*.jpg, \*.jpe (see the *Notes* section)
-   JPEG 2000 files - \*.jp2 (see the *Notes* section)
-   Portable Network Graphics - \*.png (see the *Notes* section)
-   WebP - \*.webp (see the *Notes* section)
-   Portable image format - \*.pbm, \*.pgm, \*.ppm \*.pxm, \*.pnm (always supported)
-   Sun rasters - \*.sr, \*.ras (always supported)
-   TIFF files - \*.tiff, \*.tif (see the *Notes* section)
-   OpenEXR Image files - \*.exr (see the *Notes* section)
-   Radiance HDR - \*.hdr, \*.pic (always supported)
-   Raster and Vector geospatial data supported by Gdal (see the *Notes* section)
<p>
\note
<p>
-   The function determines the type of an image by the content, not by the file extension.
-   In the case of color images, the decoded images will have the channels stored in **B G R** order.
-   On Microsoft Windows\* OS and MacOSX\*, the codecs shipped with an OpenCV image (libjpeg,
    libpng, libtiff, and libjasper) are used by default. So, OpenCV can always read JPEGs, PNGs,
    and TIFFs. On MacOSX, there is also an option to use native MacOSX image readers. But beware
    that currently these native image loaders give images with different pixel values because of
    the color management embedded into MacOSX.
-   On Linux\*, BSD flavors and other Unix-like open-source operating systems, OpenCV looks for
    codecs supplied with an OS image. Install the relevant packages (do not forget the development
    files, for example, "libjpeg-dev", in Debian\* and Ubuntu\*) to get the codec support or turn
    on the OPENCV_BUILD_3RDPARTY_LIBS flag in CMake.
-   In the case you set *WITH_GDAL* flag to true in CMake and \ref IMREAD_LOAD_GDAL to load the image,
    then [GDAL](http://www.gdal.org) driver will be used in order to decode the image by supporting
    the following formats: [Raster](http://www.gdal.org/formats_list.html),
    [Vector](http://www.gdal.org/ogr_formats.html).
-   If EXIF information are embedded in the image file, the EXIF orientation will be taken into account
    and thus the image will be rotated accordingly except if the flag \ref IMREAD_IGNORE_ORIENTATION is passed.
@param filename Name of file to be loaded.
@param flags Flag that can take values of cv::ImreadModes
*/
@Namespace("cv") public static native @ByVal Mat imread( @Str BytePointer filename, int flags/*=cv::IMREAD_COLOR*/ );
@Namespace("cv") public static native @ByVal Mat imread( @Str BytePointer filename );
@Namespace("cv") public static native @ByVal Mat imread( @Str String filename, int flags/*=cv::IMREAD_COLOR*/ );
@Namespace("cv") public static native @ByVal Mat imread( @Str String filename );

/** \brief Loads a multi-page image from a file.
<p>
The function imreadmulti loads a multi-page image from the specified file into a vector of Mat objects.
@param filename Name of file to be loaded.
@param flags Flag that can take values of cv::ImreadModes, default with cv::IMREAD_ANYCOLOR.
@param mats A vector of Mat objects holding each page, if more than one.
\sa cv::imread
*/
@Namespace("cv") public static native @Cast("bool") boolean imreadmulti(@Str BytePointer filename, @ByRef MatVector mats, int flags/*=cv::IMREAD_ANYCOLOR*/);
@Namespace("cv") public static native @Cast("bool") boolean imreadmulti(@Str BytePointer filename, @ByRef MatVector mats);
@Namespace("cv") public static native @Cast("bool") boolean imreadmulti(@Str String filename, @ByRef MatVector mats, int flags/*=cv::IMREAD_ANYCOLOR*/);
@Namespace("cv") public static native @Cast("bool") boolean imreadmulti(@Str String filename, @ByRef MatVector mats);

/** \brief Saves an image to a specified file.
<p>
The function imwrite saves the image to the specified file. The image format is chosen based on the
filename extension (see cv::imread for the list of extensions). Only 8-bit (or 16-bit unsigned (CV_16U)
in case of PNG, JPEG 2000, and TIFF) single-channel or 3-channel (with 'BGR' channel order) images
can be saved using this function. If the format, depth or channel order is different, use
Mat::convertTo , and cv::cvtColor to convert it before saving. Or, use the universal FileStorage I/O
functions to save the image to XML or YAML format.
<p>
It is possible to store PNG images with an alpha channel using this function. To do this, create
8-bit (or 16-bit) 4-channel image BGRA, where the alpha channel goes last. Fully transparent pixels
should have alpha set to 0, fully opaque pixels should have alpha set to 255/65535.
<p>
The sample below shows how to create such a BGRA image and store to PNG file. It also demonstrates how to set custom
compression parameters :
\include snippets/imgcodecs_imwrite.cpp
@param filename Name of the file.
@param img Image to be saved.
@param params Format-specific parameters encoded as pairs (paramId_1, paramValue_1, paramId_2, paramValue_2, ... .) see cv::ImwriteFlags
*/
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal Mat img,
              @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal Mat img);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal Mat img,
              @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal Mat img);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal Mat img,
              @StdVector int[] params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal UMat img,
              @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal UMat img);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal UMat img,
              @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal UMat img);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal UMat img,
              @StdVector int[] params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal GpuMat img,
              @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal GpuMat img);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal GpuMat img,
              @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal GpuMat img);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal GpuMat img,
              @StdVector int[] params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal Mat img,
              @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal Mat img,
              @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal Mat img,
              @StdVector int[] params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal UMat img,
              @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal UMat img,
              @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal UMat img,
              @StdVector int[] params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal GpuMat img,
              @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str BytePointer filename, @ByVal GpuMat img,
              @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imwrite( @Str String filename, @ByVal GpuMat img,
              @StdVector int[] params/*=std::vector<int>()*/);

/** \brief Reads an image from a buffer in memory.
<p>
The function imdecode reads an image from the specified buffer in the memory. If the buffer is too short or
contains invalid data, the function returns an empty matrix ( Mat::data==NULL ).
<p>
See cv::imread for the list of supported formats and flags description.
<p>
\note In the case of color images, the decoded images will have the channels stored in **B G R** order.
@param buf Input array or vector of bytes.
@param flags The same flags as in cv::imread, see cv::ImreadModes.
*/
@Namespace("cv") public static native @ByVal Mat imdecode( @ByVal Mat buf, int flags );
@Namespace("cv") public static native @ByVal Mat imdecode( @ByVal UMat buf, int flags );
@Namespace("cv") public static native @ByVal Mat imdecode( @ByVal GpuMat buf, int flags );

/** \overload
@param buf
@param flags
@param dst The optional output placeholder for the decoded matrix. It can save the image
reallocations when the function is called repeatedly for images of the same size.
*/
@Namespace("cv") public static native @ByVal Mat imdecode( @ByVal Mat buf, int flags, Mat dst);
@Namespace("cv") public static native @ByVal Mat imdecode( @ByVal UMat buf, int flags, Mat dst);
@Namespace("cv") public static native @ByVal Mat imdecode( @ByVal GpuMat buf, int flags, Mat dst);

/** \brief Encodes an image into a memory buffer.
<p>
The function imencode compresses the image and stores it in the memory buffer that is resized to fit the
result. See cv::imwrite for the list of supported formats and flags description.
<p>
@param ext File extension that defines the output format.
@param img Image to be written.
@param buf Output buffer resized to fit the compressed image.
@param params Format-specific parameters. See cv::imwrite and cv::ImwriteFlags.
*/
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector BytePointer buf,
                            @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector BytePointer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf,
                            @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector byte[] buf,
                            @StdVector int[] params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector byte[] buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector BytePointer buf,
                            @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector BytePointer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf,
                            @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector byte[] buf,
                            @StdVector int[] params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector byte[] buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector BytePointer buf,
                            @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector BytePointer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf,
                            @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector byte[] buf,
                            @StdVector int[] params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector byte[] buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector BytePointer buf,
                            @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector BytePointer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf,
                            @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector byte[] buf,
                            @StdVector int[] params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal Mat img,
                            @Cast("uchar*") @StdVector byte[] buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector BytePointer buf,
                            @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector BytePointer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf,
                            @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector byte[] buf,
                            @StdVector int[] params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal UMat img,
                            @Cast("uchar*") @StdVector byte[] buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector BytePointer buf,
                            @StdVector IntPointer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector BytePointer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf,
                            @StdVector IntBuffer params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str BytePointer ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector ByteBuffer buf);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector byte[] buf,
                            @StdVector int[] params/*=std::vector<int>()*/);
@Namespace("cv") public static native @Cast("bool") boolean imencode( @Str String ext, @ByVal GpuMat img,
                            @Cast("uchar*") @StdVector byte[] buf);

/** \} imgcodecs */

 // cv

// #endif //OPENCV_IMGCODECS_HPP


}
